
/*
Esercizio2
	un programmino di esempio sull'uso delle pipe e le configurazioni
	client/server in C

config.h
	ho raccolto qui tutto quello che puo` essere modificato in questo
	programma, happy hacking! ;)
	In particolare occhio alle definizioni per il parser!!!

Copyright (C) 1998 Marco Gaiarin (gaio@pluto.linux.it)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.		*/


// comment out to reduce debugging...
//#define DEBUG

// base pipe name
#ifndef PNAME
#define PNAME	"/tmp/gaio_pipe"
#endif

// permessi di default
#ifndef PMODE
#define PMODE	0600
#endif

// lunghezza di default dei comandi
#ifndef CLEN
#define CLEN	8
#endif

// lunghezza di default dei nomi delle pipe
#ifndef PNLEN
#define PNLEN	25
#endif

// lunghezza di default dei PID in decimale (16 bit -> 64K -> 6 cifre)
#ifndef PIDLEN
#define PIDLEN	6
#endif

// lunghezza massima delle stringhe in input
#ifndef BUFLMAX
#define BUFLMAX	50
#endif

// qualche definizione per i codici di errore...
#define	CDERR	1	// create/destroy
#define OCERR	2	// open/close
#define RWERR	3	// read/write
#define	FWERR	4	// fork/wait
#define SERR	5	// sting error
#define	OERR	9	// tutto il resto

// mi piacciono... ;)))
#define STDIN	0
#define STDOUT	1
#define STDERR	2



//		definizioni per il parser

// numero di comandi, da aumentare se ne aggiungete altrimenti non li caga
// manco di striscio... ;)))
#define PCMD	10

// comandi veri e propri, notare lo static...
static char	*cmds[PCMD] 	=
	{	"ls\0",
		"date\0",
		"ps\0",
		"df\0",
		"du\0",
		"who\0",	// who e` un buco di sicurezza!
		"finger\0",	// idem finger
		"pwd\0",
		"cal\0",
		"free\0"
	};

// path dei comandi, presi da Linux quindi potrebbe esserci il bisogno
// di rivederli...
static char	*cmdpath[PCMD]	=
	{	"/bin/ls\0",
		"/bin/date\0",
		"/bin/ps\0",
		"/bin/df\0",
		"/usr/bin/du\0",
		"/usr/bin/who\0",
		"/usr/bin/finger\0",
		"/bin/pwd\0",
		"/usr/bin/cal\0",
		"/usr/bin/free\0"
	};
